Attribute VB_Name = "Mapper_More"
'olafnes already have(new added)
'1,2,3,4,6,7,(8),9,11,13,15,16,17,19,22,23,24,32,33,34,40,(57),
'64,65,66,68,69,71,74,(75),78,85,90,91,(94),107,118,151,(250)
'
'

Public MMC_Reg(10) As Byte, MMC_Chr(8) As Byte, MMC_Prg(8) As Byte, MMC_Bank(8) As Byte

Public Sub map8_write(Address As Long, value As Byte) 'mapper 8=66
    If (Address >= &H6000&) Then
        reg8 = 4 * ((value And &HF0) \ &H10)
        regA = reg8 + 1
        regC = reg8 + 2
        regE = reg8 + 3
        Call SetupBanks
        Call Select8KVROM(value And &HF)
    End If
End Sub
Public Sub map57_write(Address As Long, value As Byte)
    Select Case Address
    Case &H8000& To &H8003&
        If value And &H40& Then
            Select8KVROM (value And &H3&) + ((MMC_Reg(0) And &H10&) \ &H2&) + (MMC_Reg(0) And 7)
        End If
    Case &H8800&
        MMC_Reg(0) = value
        If value And &H80& Then
            reg8 = ((value And &H40&) \ &H40&) * 4 + 8
            regA = reg8 + 1
            regC = reg8 + 2
            regE = reg8 + 3
        Else
            reg8 = ((value And &H60&) \ &H20&) * 2
            regA = reg8 + 1
            regC = reg8
            regE = regA
        End If
        Call SetupBanks
        Select8KVROM (value And 7) + ((value And &H10&) \ &H2&)
        If value And 8 Then Mirroring = 0 Else Mirroring = 1
    End Select
End Sub
Public Sub map75_write(Address As Long, value As Byte)
    Select Case (Address And &HF000)
        Case &H8000
            reg8 = value
            Call SetupBanks
        Case &H9000
            If value And 1 Then Mirroring = 0 Else Mirroring = 1
            domirror
            MMC_Prg(0) = (MMC_Prg0 And &HF) Or ((value And 2) * 8)
            MMC_Prg(1) = (MMC_Prg1 And &HF) Or ((value And 4) * 4)
            Select4KVROM MMC_Prg(0), 0
            Select4KVROM MMC_Prg(1), 1
        Case &HA000
            regA = value
            Call SetupBanks
        Case &HC000
            regC = value
            Call SetupBanks
        Case &HE000
            MMC_Prg(0) = (MMC_Prg(0) And &H10) Or (value And &HF)
            Select4KVROM MMC_Prg(0), 0
        Case &HF000
            MMC_Prg(1) = (MMC_Prg1 And &H10) Or (value And &HF)
            Select4KVROM MMC_Prg(1), 1
    End Select
End Sub
Public Sub map77_write(Address As Long, value As Byte)
    Mirroring = 4
    reg8 = 4 * (value And &H7&)
    regA = reg8 + 1
    regC = reg8 + 2
    regE = reg8 + 3
    Call SetupBanks
    Select2KVROM ((value And &HF0&) \ &H10&), 0
End Sub
Public Sub map79_write(Address As Long, value As Byte)
    If (Address And &H100&) Then
        reg8 = 4 * ((value \ &H8&) And &H1&)
        regA = reg8 + 1
        regC = reg8 + 2
        regE = reg8 + 3
        Call SetupBanks
        Select8KVROM value And &H7
    End If
End Sub
Public Sub map94_write(Address As Long, value As Byte)
    If (Address And &HFFF0) = &HFF00 Then
        reg8 = ((value \ 4) And 7) * 2
        regA = reg8 + 1
        Call SetupBanks
    End If
End Sub
Public Sub map250_write(Address As Long, value As Byte)
    Dim tempadd As Long
    Dim tempval As Byte
    tempadd = (Address And &HE000) Or ((Address And &H400) \ &H400)
    tempval = Address And &HFF
    map4_write tempadd, tempval
End Sub
