Attribute VB_Name = "mapper1"
Option Explicit

Public Sub map1_write(Address As Long, value As Byte)
  Dim bank_select As Long
  If (value And &H80) Then
    data(0) = data(0) Or &HC
    accumulator = data((Address \ &H2000&) And 3)
    sequence = 5
  Else
    If value And 1 Then
      accumulator = accumulator Or pow2(sequence)
    End If
    sequence = sequence + 1
  End If
  If (sequence = 5) Then
    data(Address \ &H2000& And 3) = accumulator
    sequence = 0
    accumulator = 0
    If (PrgCount = &H20) Then
      bank_select = (data(1) And &H10) * 2
    Else
      bank_select = 0
    End If
    Select Case data(0) And 3
      Case 0
        Mirroring = 2
      Case 1
        Mirroring = 3
      Case 2
        Mirroring = 1
      Case 3
        Mirroring = 0
    End Select
    Call DoMirror
    If (data(0) And 8) = 0 Then
      reg8 = 4 * (data(3) And 15) + bank_select
      regA = 4 * (data(3) And 15) + bank_select + 1
      regC = 4 * (data(3) And 15) + bank_select + 2
      regE = 4 * (data(3) And 15) + bank_select + 3
      Call SetupBanks
    ElseIf (data(0) And 4) Then
      reg8 = ((data(3) And 15) * 2) + bank_select
      regA = ((data(3) And 15) * 2) + bank_select + 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
    Else
      reg8 = 0
      regA = 1
      regC = ((data(3) And 15) * 2) + bank_select
      regE = ((data(3) And 15) * 2) + bank_select + 1
      Call SetupBanks
    End If
    If (data(0) And &H10) Then
      Call Select4KVROM(data(1), 0)
      Call Select4KVROM(data(2), 1)
    Else
      Call Select8KVROM(data(1) \ 2)
    End If
  End If
End Sub

