Attribute VB_Name = "mapper15"
Option Explicit

Public Sub map15_write(address As Long, value As Byte)
  Map15_BankAddr = (value And &H3F) * 2
  Select Case (address And &H3)
    Case &H0
      map15_swapaddr = (value And &H80)
      reg8 = Map15_BankAddr
      regA = Map15_BankAddr + 1
      regC = Map15_BankAddr + 2
      regE = Map15_BankAddr + 3
      Call SetupBanks
      Mirroring = (value And &H40) \ &H40
    Case &H1
      Map15_SwapReg = (value And &H80)
      regC = Map15_BankAddr
      regE = Map15_BankAddr + 1
      Call SetupBanks
    Case &H2
      If (value And &H80) Then
        reg8 = Map15_BankAddr + 1
        regA = Map15_BankAddr + 1
        regC = Map15_BankAddr + 1
        regE = Map15_BankAddr + 1
      Else
        reg8 = Map15_BankAddr
        regA = reg8
        regC = regA
        regE = regC
      End If
      Call SetupBanks
    Case &H3
      Map15_SwapReg = (value And &H80)
      regC = Map15_BankAddr
      regE = Map15_BankAddr + 1
      Call SetupBanks
      Mirroring = (value And &H40&) \ &H40&
  End Select
End Sub
