Attribute VB_Name = "mapper16"
Option Explicit

Public Sub map16_irq()
  If (MMC16_IrqOn <> 0) Then
    MMC16_Irq = MMC16_Irq - 1
    If (MMC16_Irq = 0) Then
      Call irq6502
      MMC16_IrqOn = 0
    End If
  End If
End Sub

Public Sub map16_write(address As Long, value As Byte)
  Select Case (address And &HD)
    Case &H0 To &H7
      Call Select1KVROM(value, address And &H7)
    Case &H8
      reg8 = value * 2
      regA = reg8 + 1
      Call SetupBanks
    Case &H9
      Mirroring = (value And &H1)
    Case &HA
      If value Then
        MMC16_IrqOn = 1
      Else
        MMC16_IrqOn = 0
      End If
    Case &HB
      tmpLatch = value
    Case &HC
      MMC16_Irq = (value * &H100&) + tmpLatch
    Case &HD
  End Select
End Sub
