Attribute VB_Name = "mapper22"
Option Explicit

Public map22_hichr(7) As Byte

Public map22_lochr(7) As Byte

Public Sub map22_write(Address As Long, value As Byte)
  Dim page As Byte
  Select Case Address
    Case &H8000&
      reg8 = value
      Call SetupBanks
    Case &H9000&
      Mirroring = (value And &H3)
      Call domirror
    Case &HA000&
      regA = value
      Call SetupBanks
    Case &HB000&
      map22_lochr(0) = value
      page = (map22_lochr(0) And &HF) + ((map22_hichr(0) And &HF) * 16)
      Call Select1KVROM(page / 2, 0)
    Case &HB001&
      map22_lochr(1) = value
      page = (map22_lochr(1) And &HF) + ((map22_hichr(1) And &HF) * 16)
      Call Select1KVROM(page / 2, 1)
    Case &HB002&
      map22_hichr(0) = value
      page = (map22_lochr(0) And &HF) + ((map22_hichr(0) And &HF) * 16)
      Call Select1KVROM(page / 2, 0)
    Case &HB003&
      map22_hichr(1) = value
      page = (map22_lochr(1) And &HF) + ((map22_hichr(1) And &HF) * 16)
      Call Select1KVROM(page / 2, 1)
    Case &HC000&
      map22_lochr(2) = value
      page = (map22_lochr(2) And &HF) + ((map22_hichr(2) And &HF) * 16)
      Call Select1KVROM(page / 2, 2)
    Case &HC001&
      map22_lochr(3) = value
      page = (map22_lochr(3) And &HF) + ((map22_hichr(3) And &HF) * 16)
      Call Select1KVROM(page / 2, 3)
    Case &HC002&
      map22_hichr(2) = value
      page = (map22_lochr(2) And &HF) + ((map22_hichr(2) And &HF) * 16)
      Call Select1KVROM(page / 2, 2)
    Case &HC003&
      map22_hichr(3) = value
      page = (map22_lochr(3) And &HF) + ((map22_hichr(3) And &HF) * 16)
      Call Select1KVROM(page / 2, 3)
    Case &HD000&
      map22_lochr(4) = value
      page = (map22_lochr(4) And &HF) + ((map22_hichr(4) And &HF) * 16)
      Call Select1KVROM(page / 2, 4)
    Case &HD001&
      map22_lochr(5) = value
      page = (map22_lochr(5) And &HF) + ((map22_hichr(5) And &HF) * 16)
      Call Select1KVROM(page / 2, 5)
    Case &HD002&
      map22_hichr(4) = value
      page = (map22_lochr(4) And &HF) + ((map22_hichr(4) And &HF) * 16)
      Call Select1KVROM(page / 2, 4)
    Case &HD003&
      map22_hichr(5) = value
      page = (map22_lochr(5) And &HF) + ((map22_hichr(5) And &HF) * 16)
      Call Select1KVROM(page / 2, 5)
    Case &HE000&
      map22_lochr(6) = value
      page = (map22_lochr(6) And &HF) + ((map22_hichr(6) And &HF) * 16)
      Call Select1KVROM(page / 2, 6)
    Case &HE001&
      map22_lochr(7) = value
      page = (map22_lochr(7) And &HF) + ((map22_hichr(7) And &HF) * 16)
      Call Select1KVROM(page / 2, 7)
    Case &HE002&
      map22_hichr(6) = value
      page = (map22_lochr(6) And &HF) + ((map22_hichr(6) And &HF) * 16)
      Call Select1KVROM(page / 2, 6)
    Case &HE003&
      map22_hichr(7) = value
      page = (map22_lochr(7) And &HF) + ((map22_hichr(7) And &HF) * 16)
      Call Select1KVROM(page / 2, 7)
  End Select
End Sub

