Attribute VB_Name = "mapper6"
Option Explicit

Public IRQCounter As Long

Public map6_irqon As Byte

Public Function map6_hblank(Scanline) As Byte
  If (map6_irqon <> 0) Then
    IRQCounter = IRQCounter + 1
    If (IRQCounter >= &HFFFF&) Then
      IRQCounter = 0
      Call irq6502
    End If
  End If
End Function

Public Sub map6_write(address As Long, value As Byte)
  Select Case address
    Case &H42FC& To &H42FD&
    Case &H42FE&
      If value And &H20 Then
        NameTable = &H2400&
      Else
        NameTable = &H2000&
      End If
    Case &H42FF&
      Mirroring = (value And &H20) \ &H20
      Call domirror
    Case &H4501&
      map6_irqon = 0
    Case &H4502&
      tmpLatch = value
    Case &H4503&
      IRQCounter = (value * &H100&) + tmpLatch
      map6_irqon = 1
    Case &H8000& To &HFFFF&
      reg8 = (value And &HF) * 2
      regA = reg8 + 1
      Call Select8KVROM(value And &H3)
      Call SetupBanks
  End Select
End Sub

