Attribute VB_Name = "mapper64"
Option Explicit

Public Sub map64_write(address As Long, value As Byte)
  Select Case address
    Case &H8000&
      cmd = value And &HF
      prg = (value And &H40)
      chr1 = (value And &H80)
    Case &H8001&
      Select Case cmd
        Case 0
          If (chr1) Then
            Call Select1KVROM(value, 4)
            Call Select1KVROM(value + 1, 5)
          Else
            Call Select1KVROM(value, 0)
            Call Select1KVROM(value, 1)
          End If
        Case 1
          If (chr1) Then
            Call Select1KVROM(value, 6)
            Call Select1KVROM(value + 1, 7)
          Else
            Call Select1KVROM(value, 2)
            Call Select1KVROM(value + 1, 3)
          End If
        Case 2
          If (chr1) Then
            Call Select1KVROM(value, 0)
          Else
            Call Select1KVROM(value, 4)
          End If
        Case 3
          If (chr1) Then
            Call Select1KVROM(value, 1)
          Else
            Call Select1KVROM(value, 5)
          End If
        Case 4
          If (chr1) Then
            Call Select1KVROM(value, 2)
          Else
            Call Select1KVROM(value, 6)
          End If
        Case 5
          If (chr1) Then
            Call Select1KVROM(value, 3)
          Else
            Call Select1KVROM(value, 7)
          End If
        Case 6
          If (prg) Then
            regA = value
          Else
            reg8 = value
          End If
          Call SetupBanks
        Case 7
          If (prg) Then
            regC = value
          Else
            reg8 = value
          End If
          Call SetupBanks
        Case 8
          Call Select1KVROM(value, 1)
        Case 9
          Call Select1KVROM(value, 3)
        Case &HF
          If (prg) Then
            reg8 = value
          Else
            regC = value
          End If
          Call SetupBanks
      End Select
    Case &HA000&
      Mirroring = (value And &H1)
      Call domirror
  End Select
End Sub

